package cz.cvut.fel.pr2.cv03.adressbook;

/**
 * @author Ondrej Hrstka <ondrej.hrstka@agents.fel.cvut.cz>
 */
public class Record {

    private final String name,
                         surname,
                         number,
                         email,
                         city;
    private final int streetNumber,
                      zipCode;

    public Record(String name, String surname, String number, String email, String city, int streetNumber, int zipCode) {
        this.name = name;
        this.surname = surname;
        this.number = number;
        this.email = email;
        this.city = city;
        this.streetNumber = streetNumber;
        this.zipCode = zipCode;
    }

    public String getName() {
        return name;
    }

    public String getSurname() {
        return surname;
    }

    public String getNumber() {
        return number;
    }

    public String getEmail() {
        return email;
    }

    public String getCity() {
        return city;
    }

    public int getStreetNumber() {
        return streetNumber;
    }

    public int getZipCode() {
        return zipCode;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Record)) return false;

        Record record = (Record) o;

        if (streetNumber != record.streetNumber) return false;
        if (zipCode != record.zipCode) return false;
        if (city != null ? !city.equals(record.city) : record.city != null) return false;
        if (email != null ? !email.equals(record.email) : record.email != null) return false;
        if (name != null ? !name.equals(record.name) : record.name != null) return false;
        if (number != null ? !number.equals(record.number) : record.number != null) return false;
        if (surname != null ? !surname.equals(record.surname) : record.surname != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = name != null ? name.hashCode() : 0;
        result = 31 * result + (surname != null ? surname.hashCode() : 0);
        result = 31 * result + (number != null ? number.hashCode() : 0);
        result = 31 * result + (email != null ? email.hashCode() : 0);
        result = 31 * result + (city != null ? city.hashCode() : 0);
        result = 31 * result + streetNumber;
        result = 31 * result + zipCode;
        return result;
    }
}
